##### Карта памяти stm32
**Sector 0: 0x0800 0000 - 0x0800 3FFF (16кБт)
Sector 1: 0x0800 4000 - 0x0800 7FFF (16кБт) - Основные настройки (SETTINGS)
Sector 2: 0x0800 8000 - 0x0800 BFFF (16кБт) - Системные настройки (SETTINGS_SYS)
Sector 3: 0x0800 C000 - 0x0800 FFFF (16кБт)
Sector 4: 0x0801 8000 - 0x0801 FFFF (64кБт)
Sector 5: 0x0802 0000 - 0x0803 FFFF (128кБт)
Sector 6: 0x0804 0000 - 0x0805 FFFF (128кБт)
............................................
Sector 11: 0x080E 0000 - 0x080F FFFF (128кБт)**
```c
// Адреса структур настроек

#define SYS_SECTOR         		        0x08008000
#define SYS_CRC_ADDRESS                 0x0800BF9C
```

---
##### Карта памяти artery
0x0800 0000 - 0x0801 FFFF (128кБт) - **IAP**
0x0802 0000 - 0x0802 07FF (2кБт) - **Основные настройки (SETTINGS)**
0x0802 0800 - 0x0802 0FFF (2кБт) - **Системные настройки (SETTINGS_SYS)**
0x0802 1000 - 0x0809 FFFF (640кБт) - **FW**
**Итого: 772 кБт - занято**
```c
// Адреса структур настроек

#define SYS_SECTOR         		        0x08020800
#define SYS_CRC_ADDRESS                 0x08020FFC
#define SETTINGS_SECTOR                 0x08020000
```
---
### Периферия (Artery)
**Таймеры TIM**
TIM7 - используется для периодических измерений ADC
TIM13 - используется в IAP для внешнего watchdog
TIM6 - используется для подсчета uptime и ежусуточного watchdog

---
##### Сборка web-интерфейса (fsdata.c)
- Для сборки должен быть установлен node.js (v16.x.x +), nmp, perl.
- В корневом каталоге web-интерфейса (metrolog_modem_web_ui) выполнить:
Cборку web'a для основного FW:
```bash
npm run build:wui
```
Сборку web'a для IAP, указав версию IAP для отображения в web-интерфейсе:
```bash
npm run build:upload -- --iap=1.01
```
- Собрать fsdata.c для FW:
```perl
perl tools\makefsdata.pl fw\modules\http_server\ metrolog_modem_web_ui\dist\wui\
```
- Собрать fsdata.c для IAP:
```perl
perl tools\makefsdata.pl iap\modules\ethernet\ metrolog_modem_web_ui\dist\upload\
```
---
##### TODO
- [x] работа с настройками
	- [x] внутренний модуль artery для работы с CRC
	- [x] отдельные сектора для системных и основных настроек
	- [x] системные настройки
	- [x] основные настройки
- [x] Artery ID
- [x] backup регистры
- [x] RTC
- [x] SNTP
- [x] настроить кучу FreeRTOS. Разобраться с RAM artery
	- [x] IAP
	- [x] FW
- [x] GSM - uart драйвер
- [x] Кнопки
- [x] LED
	- [x] Основное
	- [x] Некоторые функции из других модулей
- [x] LwIP
- [x] ethernet
- [x] power manager
- [x] определение ревизий (mboard_rev, dboard_rev)
- [x] параметры parameters.c
- [x] файл netconf
- [x] web_params_api
- [x] upload.c
- [x] UDP анонсы
- [x] uptime
- [x] ping со стороны Метролога
- [x] log
- [x] http server
- [x] Random generator
- [x] monitor
- [x] BUZZER
- [x] digital inputs
- [x] Static IP address
- [x] Файловая система
---


---


---



